/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
)

// checks if the CreateChannelTagRequest type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &CreateChannelTagRequest{}

// CreateChannelTagRequest struct for CreateChannelTagRequest
type CreateChannelTagRequest struct {
	Name *string `json:"name,omitempty"`
}

// NewCreateChannelTagRequest instantiates a new CreateChannelTagRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewCreateChannelTagRequest() *CreateChannelTagRequest {
	this := CreateChannelTagRequest{}
	return &this
}

// NewCreateChannelTagRequestWithDefaults instantiates a new CreateChannelTagRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewCreateChannelTagRequestWithDefaults() *CreateChannelTagRequest {
	this := CreateChannelTagRequest{}
	return &this
}

// GetName returns the Name field value if set, zero value otherwise.
func (o *CreateChannelTagRequest) GetName() string {
	if o == nil || IsNil(o.Name) {
		var ret string
		return ret
	}
	return *o.Name
}

// GetNameOk returns a tuple with the Name field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CreateChannelTagRequest) GetNameOk() (*string, bool) {
	if o == nil || IsNil(o.Name) {
		return nil, false
	}
	return o.Name, true
}

// HasName returns a boolean if a field has been set.
func (o *CreateChannelTagRequest) HasName() bool {
	if o != nil && !IsNil(o.Name) {
		return true
	}

	return false
}

// SetName gets a reference to the given string and assigns it to the Name field.
func (o *CreateChannelTagRequest) SetName(v string) {
	o.Name = &v
}

func (o CreateChannelTagRequest) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o CreateChannelTagRequest) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Name) {
		toSerialize["name"] = o.Name
	}
	return toSerialize, nil
}

type NullableCreateChannelTagRequest struct {
	value *CreateChannelTagRequest
	isSet bool
}

func (v NullableCreateChannelTagRequest) Get() *CreateChannelTagRequest {
	return v.value
}

func (v *NullableCreateChannelTagRequest) Set(val *CreateChannelTagRequest) {
	v.value = val
	v.isSet = true
}

func (v NullableCreateChannelTagRequest) IsSet() bool {
	return v.isSet
}

func (v *NullableCreateChannelTagRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableCreateChannelTagRequest(val *CreateChannelTagRequest) *NullableCreateChannelTagRequest {
	return &NullableCreateChannelTagRequest{value: val, isSet: true}
}

func (v NullableCreateChannelTagRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableCreateChannelTagRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


